package net.woodyfolsom.msproj.policy;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import net.woodyfolsom.msproj.Action;
import net.woodyfolsom.msproj.GameConfig;
import net.woodyfolsom.msproj.GameState;
import net.woodyfolsom.msproj.Player;

import org.junit.Test;

public class MinimaxTest {
	@Test
	public void testGenmoveAsW() {
		Policy treeSearch = new Minimax();
		GameConfig gameConfig = new GameConfig(6);
		GameState gameState = new GameState(gameConfig);
		assertTrue(gameState.placeStone(Player.WHITE, Action.getInstance("A2")));
		assertTrue(gameState.placeStone(Player.WHITE, Action.getInstance("B1")));
		assertTrue(gameState.placeStone(Player.WHITE, Action.getInstance("C2")));
		assertTrue(gameState.placeStone(Player.BLACK, Action.getInstance("B2")));
		assertTrue(gameState.playStone(Player.BLACK, Action.PASS));
		
		Action move = treeSearch.getAction(gameConfig, gameState,
				Player.WHITE);

		System.out.println(gameState);

		System.out.println("Generated move: " + move);
		System.out.println("NumStateEvaluations: " + treeSearch.getNumStateEvaluations());
		
		assertEquals(Action.getInstance("B3"), move);
		assertTrue(gameState.playStone(Player.WHITE, move));

		System.out.println(gameState);
	}

	@Test
	public void testGenmoveAsB() {
		Policy treeSearch = new Minimax();
		GameConfig gameConfig = new GameConfig(6);
		GameState gameState = new GameState(gameConfig);
		assertTrue(gameState.placeStone(Player.BLACK, Action.getInstance("A2")));
		assertTrue(gameState.placeStone(Player.BLACK, Action.getInstance("B1")));
		assertTrue(gameState.placeStone(Player.BLACK, Action.getInstance("C2")));
		assertTrue(gameState.placeStone(Player.WHITE, Action.getInstance("B2")));

		Action move = treeSearch.getAction(gameConfig, gameState,
				Player.BLACK);

		System.out.println(gameState);

		System.out.println("Generated move: " + move);
		System.out.println("NumStateEvaluations: " + treeSearch.getNumStateEvaluations());
		
		assertEquals("Expected B3 but was: " + move, Action.getInstance("B3"), move);
		assertTrue(gameState.playStone(Player.BLACK, move));

		System.out.println(gameState);
	}
}